defmodule DrainCloudCoreWeb.AuthController do
  use DrainCloudCoreWeb, :controller

  import Plug.Conn

  alias DrainCloudCoreWeb.AuthController.RegisterRequest, as: RegisterRequest
  alias DrainCloudCoreWeb.AuthController.LoginRequest, as: LoginRequest
  alias :logger, as: Log
  alias DrainCloudCore.Auth.Users , as: Repo

  def register(conn, _params) do
    try do
      RegisterRequest.from_request(conn)
      |> RegisterRequest.to_model
      |> Repo.add_user
      # TODO send cookies and tokens
      send_resp(conn, 200, Jason.encode! %{ok: true})
    rescue
      e in RuntimeError ->
        Log.error("failed to insert new user: #{e}")
        raise e
    end
  end

  def login(conn, _params) do
    try do
    LoginRequest.from_request(conn)
    # TODO send cookies and tokens
    send_resp(conn, 200, Jason.encode! %{ok: true})
    rescue
      e in RuntimeError ->
        Log.error("failed to insert new user: #{e}")
        raise e
    end
  end
end
