defmodule DrainCloudCoreWeb.Errors.InvalidArgumentException do
  @derive [Jason.Encoder]

  alias __MODULE__, as: InvalidArgumentException
  defexception [:message, :args]

  @impl true
  def exception(%{message: message, args: args}) do
    %InvalidArgumentException{message: message, args: args}
  end

  @impl true
  def exception(term) do
    case term do
      [] -> %InvalidArgumentException{}
      _ -> %InvalidArgumentException{message: "Error: " <> term}
    end
  end

  defimpl String.Chars, for: __MODULE__ do
    def to_string(err) do
      case Jason.encode(err) do
        {:ok, str} -> str
        {:error, msg} -> raise "failed to encode register request to string: #{msg}"
      end
    end
  end
end
